/*
 * "Build Engine & Tools" Copyright (c) 1993-1997 Ken Silverman
 * Ken Silverman's official web site: "http://www.advsys.net/ken"
 * See the included license file "BUILDLIC.TXT" for license info.
 * This file IS NOT A PART OF Ken Silverman's original release.
 */

#if (!defined _MSC_VER)
#error This should only be included on Microsoft Visual C compiles.
#else

/*
This was converted from pragmas.h with the following Perl script and
 a bunch of manually editing:

#!/usr/bin/perl -w

use strict;

my $in_block = 0;

while (<STDIN>) {
    chomp;
    1 while (s/[ \t]\Z//);  # trim ending whitespace.

    if (s/\);\Z/)/) {
    	print "$_\n{\n    __asm\n    {\n";
    }

   elsif (/\#pragma aux/) {
       $in_block = 1;
    }

    elsif ($_ eq "") {
    	if ($in_block) {
    	    print "    }\n}\n\n";
    	    $in_block = 0;
    	} else {
    	    print "\n";
    	}
    }

    else {
    	if ($in_block) {
    	    1 while (s/\A[ \t]//);
    	    s/\",\\//;
    	    s/\"//;
                print "        ";
    	}
    	print "$_\n";
    }
}
*/
long is_vmware_running(void);

#include <windows.h>
static HANDLE hConsole = NULL;

void win32_cls( )
{
   COORD coordScreen = { 0, 0 };    // home for the cursor 
   DWORD cCharsWritten;
   CONSOLE_SCREEN_BUFFER_INFO csbi; 
   DWORD dwConSize;

// Get the number of character cells in the current buffer. 

   if (!hConsole) 
   {
	   hConsole = GetStdHandle(STD_OUTPUT_HANDLE);
   }

   if( !GetConsoleScreenBufferInfo( hConsole, &csbi ))
      return;
   dwConSize = csbi.dwSize.X * csbi.dwSize.Y;

   // Fill the entire screen with blanks.

   if( !FillConsoleOutputCharacter( hConsole, (TCHAR) ' ',
      dwConSize, coordScreen, &cCharsWritten ))
      return;

   // Get the current text attribute.

   if( !GetConsoleScreenBufferInfo( hConsole, &csbi ))
      return;

   // Set the buffer's attributes accordingly.

   if( !FillConsoleOutputAttribute( hConsole, csbi.wAttributes,
      dwConSize, coordScreen, &cCharsWritten ))
      return;

   // Put the cursor at its home coordinates.

   SetConsoleCursorPosition( hConsole, coordScreen );
}

void win32_printchrasm(int x,int y,unsigned int ch)
{
	static CHAR_INFO c[1];

	COORD coord = {1,1};
	COORD coord2 = {0,0};
	SMALL_RECT region;

	x = (x&~0xb8000)>>1;
	y = x/80;
	x = x%80;

	region.Left = region.Right = x;
	region.Top = region.Bottom = y;
	c->Attributes = ch>>8;
	c->Char.UnicodeChar = ch&0xFF;

	if (!hConsole) 
	{
		hConsole = GetStdHandle(STD_OUTPUT_HANDLE);
	}

	WriteConsoleOutput(hConsole, c, coord, coord2, &region);
}

void win32_printstr(short x, short y, char string[81], char attribute)
{
	static CHAR_INFO chars[81];
	CHAR_INFO *c = chars;
	COORD coord = {0,1};
	COORD coord2 = {0,0};
	SMALL_RECT region = {x,y,x,y};

	while (*string)
	{
		c->Char.UnicodeChar = *string++;
		c->Attributes = attribute;
		c++;
		coord.X++;
	}
	region.Right += coord.X-1;

	WriteConsoleOutput(hConsole, chars, coord, coord2, &region);
}

void win32_writeconbuffer(char buffer[4000])
{
	static CHAR_INFO chars[2000];
	char *end = buffer+4000;
	CHAR_INFO *c = chars;
	COORD coord = {80,25};
	COORD coord2 = {0,0};
	SMALL_RECT region = {0,0,79,24};

	while (buffer < end)
	{
		c->Char.UnicodeChar = *buffer++;
		c->Attributes = *buffer++;
		c++;
	}

	win32_cls();
	WriteConsoleOutput(hConsole, chars, coord, coord2, &region);
}

static int input_character = 0;
static BYTE KeyStatesByte[256];
static WORD KeyStatesWord[256];

void w32c_FlushKeyboardQueue()
{
	int i;

	GetKeyboardState(KeyStatesByte);

	for (i = 0; i < 256; i++) KeyStatesWord[i] = GetAsyncKeyState(i);
}

int w32c_KeyWaiting()
{
	int i;
	HKL layout = GetKeyboardLayout(0);
	input_character = 0;

	Sleep(1);

	for (i = 0; i < 256; i++)
	{
		WORD new_KeyState = GetAsyncKeyState(i);

		// Looks like we might have ourselves a key
		if (KeyStatesWord[i] != new_KeyState && (new_KeyState & 0x8000))
		{

			WORD	character[4];
			int		ret;

			ret = character[0] = MapVirtualKey(i,2);

			// Yay!
			if (ret)
			{
				int shifted = (GetAsyncKeyState(VK_SHIFT) & 0x8000) != 0;
				int caps = (GetKeyState(VK_CAPITAL) & 0x1) != 0;

				if (shifted != caps)
					input_character = toupper(character[0]&0xFF);
				else
					input_character = tolower(character[0]&0xFF);

				return 1;
			}
		}
		KeyStatesWord[i] = new_KeyState;
	}

	return 0;
}

int w32c_GetCh()
{
	GetKeyboardState(KeyStatesByte);
	return input_character;
}


#endif /* defined _MSC_VER */

/* end of pragmas_visualc.h ... */


