#ifndef _INCL_DUKEWIN_H_
#define _INCL_DUKEWIN_H_ 1

#ifndef _MSC_VER  /* might need this. */
typedef long long __int64;
#endif

//#define malloc(x) calloc(x,1)

#define STUBBED(x)
//#define STUBBED(x) fprintf(stderr,"STUB: %s (%s:%d)\n",x,__FILE__,__LINE__)

#pragma warning(disable:4761)

#if USE_SDL
#include "SDL.h"
#endif

#define __far
#define __interrupt

#define PATH_SEP_CHAR '\\'
#define PATH_SEP_STR  "\\"

#include <sys/stat.h>
#include <io.h>
#include <assert.h>

struct find_t
{
	long handle;
    struct _finddata_t data;
	char name[MAX_PATH];
};
int _dos_findfirst(char *filename, int x, struct find_t *f);
int _dos_findnext(struct find_t *f);

struct dosdate_t
{
    unsigned char day;
    unsigned char month;
    unsigned int year;
    unsigned char dayofweek;
};

void _dos_getdate(struct dosdate_t *date);

#ifndef min
#define min(x, y) ((x) < (y) ? (x) : (y))
#endif

#ifndef max
#define max(x, y) ((x) > (y) ? (x) : (y))
#endif

#ifdef FP_OFF
#undef FP_OFF
#endif
#define FP_OFF(x) ((long) (x))

// 64 megs should be enough for anybody.  :)  --ryan.
#define Z_AvailHeap() ((64 * 1024) * 1024)

#ifndef USE_SDL_CONBUFFER

void win32_cls( );
void win32_printchrasm(int x,int y,unsigned int ch);
void win32_printstr(short x, short y, char string[81], char attribute);
void win32_writeconbuffer(char buffer[4000]);
void w32c_FlushKeyboardQueue();
int w32c_KeyWaiting();
int w32c_GetCh();

#define _cls win32_cls
#define _writeconbuffer(buffer) win32_writeconbuffer(buffer)
#define _printstr(x,y,str,attr) win32_printstr(x,y,str,attr)
#define _printchrasm(x,y,ch) win32_printchrasm(x,y,ch)
#define _puts(str) puts(str)
#define _putchar(c) putchar(c)
#define _printf printf
#define _KB_FlushKeyboardQueue w32c_FlushKeyboardQueue
#define _KB_KeyWaiting w32c_KeyWaiting
#define _KB_Getch w32c_GetCh

#else

void _sdl_cls( );
void _sdl_writeconbuffer(char buffer[4000]);
void _sdl_printstr(short x, short y, char string[81], char attribute);
void _sdl_printchrasm(int x,int y,unsigned int ch);
int _sdl_puts(const char *str);
int _sdl_putchar(char c);
int _sdl_printf(const char *fmt, ...);

#define _cls() _sdl_cls
#define _writeconbuffer(buffer) _sdl_writeconbuffer(buffer)
#define _printstr(x,y,str,attr) _sdl_printstr(x,y,str,attr)
#define _printchrasm(x,y,ch) _sdl_printchrasm(x,y,ch)
#define _puts(str) _sdl_puts(str)
#define _putchar(c) _sdl_putchar(c)
#define _printf _sdl_printf
#define _KB_FlushKeyboardQueue KB_FlushKeyboardQueue
#define _KB_KeyWaiting KB_KeyWaiting
#define _KB_Getch KB_GetCh

#endif

#define cdecl

#define open _open
#define O_BINARY _O_BINARY
#define O_RDONLY _O_RDONLY
#define O_WRONLY _O_WRONLY
#define O_RDWR _O_RDWR
#define O_TRUNC _O_TRUNC
#define O_CREAT _O_CREAT
#define S_IREAD _S_IREAD
#define S_IWRITE _S_IWRITE
#define S_IRDWR _S_IRDWR

#define S_IRUSR S_IREAD
#define S_IWUSR S_IWRITE
#define S_IRGRP 0
#define S_IWGRP 0

#define F_OK 0

#endif
